module Chervil::AST
  class Quotation
    attr_reader :value

    def initialize(value)
      @value = value
    end

    def evaluate(env)
      if @value.is_a?(List)
        self
      else
        @value.evaluate(env)
      end
    end

    def ==(other)
      @value == other.value
    end
  end
end
